/**
 * Edit interactions module
 *
 * @module     mod_interactivevideo/editannotation
 * @copyright  2024 Sokunthearith Makara <sokunthearithmakara@gmail.com>
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("mod_interactivevideo/editannotation",["jquery","core/toast","core/notification","core/event_dispatcher","./quickform","./libraries/jquery-ui"],(function($,addToast,Notification,_ref,quickform){let player,totaltime,currentTime,{dispatchEvent:dispatchEvent}=_ref,ctRenderer={},playerReady=!1,$loader=$("#background-loading");const replaceProgressBars=percentage=>{percentage=(percentage=percentage<0?0:percentage)>100?100:percentage,$("#video-nav #progress").css("width",percentage+"%"),$("#scrollbar, #scrollhead-top").css("left",percentage+"%")},renderVideoNav=async function(annos,start,totaltime){if(0==annos.length)return void $("#video-nav ul").empty();$("#video-nav ul").empty(),$("#video-timeline-wrapper .skipsegment").remove(),annos.forEach((async x=>{const render=ctRenderer[x.type];await render.renderItemOnVideoNavigation(x)}));const time=await player.getCurrentTime();replaceProgressBars((time-start)/totaltime*100),dispatchEvent("annotationitemsrendered",{annotations:annos})};return{init:function(url,coursemodule,interaction,course,start,end,coursecontextid){let type=arguments.length>7&&void 0!==arguments[7]?arguments[7]:"yt",displayoptions=arguments.length>8?arguments[8]:void 0,userid=arguments.length>9?arguments[9]:void 0,posterimage=arguments.length>10?arguments[10]:void 0,extendedcompletion=arguments.length>11?arguments[11]:void 0;quickform();const addNotification=function(msg){let type=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"info";addToast.add(msg,{type:type})};start=Number(start),isNaN(start)&&(start=0),end=Number(end),isNaN(end)&&(end=null);let contentTypes,annotations=[];const convertSecondsToHMS=function(s){let dynamic=arguments.length>1&&void 0!==arguments[1]&&arguments[1],rounded=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];rounded&&(s=Math.round(s));let hours=Math.floor(s/3600),minutes=Math.floor((s-3600*hours)/60),seconds=s-3600*hours-60*minutes;return rounded&&seconds>59.5&&(seconds=0,minutes++,minutes>59&&(minutes=0,hours++)),minutes<10&&(minutes="0"+minutes),seconds=rounded?Math.round(seconds):parseFloat(seconds).toFixed(2),seconds<10&&(seconds="0"+seconds),dynamic&&0==hours?minutes+":"+seconds:(hours<10?"0"+hours:hours)+":"+minutes+":"+seconds};let activeid=null;const renderAnnotationItems=annotations=>{if(renderVideoNav(annotations,start,totaltime),$("#annotationwrapper .loader").remove(),$("#annotation-list").empty().removeClass("d-flex align-items-center justify-content-center"),0==annotations.length)return void $("#annotation-list").html("".concat(M.util.get_string("clickaddtoaddinteraction","mod_interactivevideo"))).addClass("d-flex align-items-center justify-content-center");annotations.sort((function(a,b){return Number(a.timestamp)-Number(b.timestamp)})),annotations.forEach((function(item){let listItem=$("#annotation-template").clone();ctRenderer[item.type].renderEditItem(annotations,listItem,item)}));let xp=annotations.filter((x=>x.xp)).map((x=>Number(x.xp))).reduce(((a,b)=>a+b),0);if($("#xp span").text(xp),activeid){const activeAnno=annotations.find((x=>x.id==activeid));activeAnno&&ctRenderer[activeAnno.type].postEditCallback(activeAnno)}},getAnnotations=()=>{const getItems=$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_items",sesskey:M.cfg.sesskey,id:interaction,contextid:M.cfg.contextid,coursecontextid:M.cfg.courseContextId}}),getContentTypes=$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_all_contenttypes",sesskey:M.cfg.sesskey,contextid:M.cfg.contextid,coursecontextid:M.cfg.courseContextId}});$.when(getItems,getContentTypes).done((async function(items,contenttypes){annotations=JSON.parse(items[0]),contentTypes=JSON.parse(contenttypes[0]),annotations=annotations.filter((x=>contentTypes.find((y=>y.name===x.type))));const getRenderers=new Promise((resolve=>{let count=0;contentTypes.forEach((x=>{require([""+x.amdmodule],(function(Type){ctRenderer[x.name]=new Type(player,annotations,interaction,course,0,0,0,0,type,0,totaltime,start,end,x,coursemodule,null,displayoptions,null,extendedcompletion,{isEditMode:!0}),count++,ctRenderer[x.name].init(),count==contentTypes.length&&resolve(ctRenderer)}))}))}));annotations.map((x=>{let prop=contentTypes.find((y=>y.name===x.type));return delete prop.author,delete prop.authorlink,delete prop.description,x.prop=JSON.stringify(prop),x.editMode=!0,x})),ctRenderer=await getRenderers,renderAnnotationItems(annotations)}))},validateTimestampFormat=(timestamp,fld,existing)=>!!/^([0-9]{2}):([0-5][0-9]):([0-5][0-9])(\.\d{2})?$/.test(timestamp)||(addNotification(M.util.get_string("invalidtimestampformat","mod_interactivevideo"),"danger"),existing?$(fld).val(existing):$(fld).val(convertSecondsToHMS(start,!1,!1)),!1),validateTimeStartEnd=(timestamp,fld,existing,seconds,checkduration,checkexisting,checkskipsegment)=>{const parts=timestamp.split(":");if(timestamp=3600*Number(parts[0])+60*Number(parts[1])+Number(parts[2]),checkduration&&(timestamp>end||timestamp<start)){const message=M.util.get_string("timemustbebetweenstartandendtime","mod_interactivevideo",{start:convertSecondsToHMS(start,!0,!1),end:convertSecondsToHMS(end,!0,!1)});return addNotification(message,"danger"),existing?$(fld).val(existing):$(fld).val(convertSecondsToHMS(start,!1,!1)),-1}if(checkexisting&&annotations.find((x=>x.timestamp==timestamp))&&timestamp!=seconds)return addNotification(M.util.get_string("interactionalreadyexists","mod_interactivevideo"),"danger"),existing?$(fld).val(existing):$(fld).val(convertSecondsToHMS(start,!1,!1)),-1;if(checkskipsegment){const skip=annotations.filter((annotation=>"skipsegment"==annotation.type)).find((x=>Number(x.timestamp)<Number(timestamp)&&Number(x.title)>Number(timestamp)));if(skip)return addNotification(M.util.get_string("interactionisbetweentheskipsegment","mod_interactivevideo",{start:convertSecondsToHMS(skip.timestamp,!0,!1),end:convertSecondsToHMS(skip.title,!0,!1)}),"danger"),existing?$(fld).val(existing):$(fld).val(convertSecondsToHMS(start,!1,!1)),-1}return timestamp},runInteraction=annotation=>{$("#annotation-modal").modal("hide"),$("#message").not("[data-placement=bottom]").not(".sticky").remove(),$("#end-screen").remove(),player.pause();ctRenderer[annotation.type].runInteraction(annotation)},updateTime=async duration=>{duration=Number(duration);let toUpdatetime=!1;return end&&0!=end||(toUpdatetime=!0),(!start||start>=duration||start<0||start>=duration)&&(toUpdatetime=!0),start=start>duration?0:start,toUpdatetime&&await $.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"update_videotime",sesskey:M.cfg.sesskey,cmid:coursemodule,courseid:course,id:interaction,start:start,end:end&&0!=end?end:duration,contextid:M.cfg.contextid}}),{start:start,end:end=!end||0==end||end>duration?duration:end}},onReady=async()=>{player.pause();if(!await player.isPaused())return await player.seek(start),void onReady();player.unMute(),player.audio&&$("#annotation-canvas").addClass("bg-black"),1==displayoptions.passwordprotected&&($("#start-screen").removeClass("d-none"),$("#video-block").removeClass("no-pointer bg-transparent")),"vimeo"!=player.type&&"html5video"!=player.type&&"panopto"!=player.type&&"peertube"!=player.type&&$("#video-block").addClass("no-pointer"),0==player.support.playbackrate?$("#changerate").remove():$("#changerate").removeClass("d-none"),0==player.support.quality?$("#changequality").remove():$("#changequality").removeClass("d-none");let t=player.totaltime;({start:start,end:end}=await updateTime(t)),totaltime=end-start;let ratio=16/9;displayoptions.usefixedratio&&0!=displayoptions.usefixedratio||(ratio=player.aspectratio),$("#video-wrapper").css("padding-bottom",1/ratio*100+"%"),playerReady=!0,$("#annotation-canvas").removeClass("d-none"),$("#timeline-wrapper #video-timeline").css({"background-image":"url("+posterimage+")","background-size":"contain","background-repeat":"no-repeat"}),$("#timeline-wrapper #duration").text(convertSecondsToHMS(end,!0)),$("#timeline-wrapper #currenttime").text(convertSecondsToHMS(start,!0));const minutes=Math.floor(totaltime/60);$("#timeline-items-wrapper").css("width",300*minutes+"px");const relWidth=$("#timeline-items").width();$("#minute-markers, #minute-markers-bg, #vseek").css("width",relWidth+"px");let startPercentage=0,newStart=start;start%60!=0&&(startPercentage=(60-start%60)/totaltime*100,newStart=start+(60-start%60),$("#minute-markers, #minute-markers-bg").append('<div class="minute-marker position-absolute"\n                        style="left: 0%;"><div class="text-white minute-label"></div></div>'));for(let i=newStart;i<=end;i+=60){let percentage=(i-newStart)/totaltime*100+startPercentage,marker="";marker=i>=3600?Math.floor(i/3600)+"h"+Math.floor(i%3600/60)+"m":Math.floor(i/60)+"m",$("#minute-markers").append('<div class="minute-marker position-absolute"\n                         style="left: '.concat(percentage,'%;"><div class="text-white minute-label">').concat(marker,"</div></div>")),$("#minute-markers-bg").append('<div class="minute-marker position-absolute"\n                            style="left: '.concat(percentage,'%;"></div>'))}end%60!=0&&$("#minute-markers, #minute-markers-bg").append('<div class="minute-marker position-absolute"\n                        style="left: 100%;"><div class="text-white minute-label"></div></div>');try{player.setCaption("")}catch(e){}$("#scrollbar, #scrollhead-top").css("left",0),getAnnotations()},onEnded=()=>{player.pause(),$("#playpause").find("i").removeClass("bi-pause-fill").addClass("bi-play-fill").toggleClass("rotate-360"),$("#video-wrapper").append('<div id="end-screen" class="border position-absolute w-100 h-100 bg-white d-flex\n                     justify-content-center align-items-center" style="top: 0; left: 0;">\n                     <button class="btn btn-danger border-0 rounded-circle" style="font-size: 1.5rem;" id="restart">\n                    <i class="bi bi-arrow-repeat" style="font-size: x-large;"></i></button></div>'),$("#video-nav #progress").css("width","100%"),$("#scrollbar, #scrollhead-top").css("left","100%"),$("#message #restart").focus();const currentAnnotation=annotations.find((annotation=>annotation.timestamp==end));currentAnnotation&&($("#annotation-list tr").removeClass("active"),$('tr[data-id="'.concat(currentAnnotation.id,'"]')).addClass("active"),$('#video-nav .annotation[data-id="'+currentAnnotation.id+'"] .item').tooltip("show"),setTimeout((function(){$('#video-nav .annotation[data-id="'+currentAnnotation.id+'"] .item').tooltip("hide")}),2e3))},onSeek=async function(t){if(!playerReady)return;(t=t?Number(t):await player.getCurrentTime())>start&&t<end&&$("#end-screen").remove();const percentage=(t-start)/totaltime*100;$("#scrollbar, #scrollhead-top").css("left",percentage+"%"),$("#timeline-wrapper #currenttime").text(convertSecondsToHMS(t,!0)),dispatchEvent("timeupdate",{time:t})};let onPlayingInterval,visualized=!1;const onPlaying=async()=>{$("#message, #end-screen").not(".sticky").remove(),$("#playpause").find("i").removeClass("bi-play-fill").addClass("bi-pause-fill").removeClass("rotate-360"),player.audio&&!visualized&&(player.visualizer(),visualized=!0);const intervalFunction=async function(){let thisTime=await player.getCurrentTime();const isPlaying=await player.isPlaying(),isEnded=await player.isEnded();if(!isPlaying)return void cancelAnimationFrame(onPlayingInterval);if(thisTime<start&&(await player.seek(start),thisTime=start),thisTime>=end||isEnded)return player.stop(end),cancelAnimationFrame(onPlayingInterval),void onEnded();dispatchEvent("timeupdate",{time:thisTime}),$("#timeline-wrapper #currenttime").text(convertSecondsToHMS(thisTime,!0));let percentage=(thisTime-start)/totaltime*100;$("#video-nav #progress").css("width",percentage+"%"),$("#scrollbar, #scrollhead-top").css("left",percentage+"%");const scrollBar=document.getElementById("scrollbar"),rect=scrollBar.getBoundingClientRect();(rect.left<0||rect.right>window.innerWidth)&&scrollBar.scrollIntoView({behavior:"instant",block:"center",inline:"center"});const currentAnnotation=annotations.find((x=>thisTime-player.frequency<=x.timestamp&&thisTime+player.frequency>=x.timestamp));currentAnnotation&&($("#annotation-list tr").removeClass("active"),$('tr[data-id="'.concat(currentAnnotation.id,'"]')).addClass("active"),$('#video-nav .annotation[data-id="'+currentAnnotation.id+'"] .item').tooltip("show"),setTimeout((function(){$('#video-nav .annotation[data-id="'+currentAnnotation.id+'"] .item').tooltip("hide")}),2e3));let skip=annotations.filter((annotation=>"skipsegment"==annotation.type)).find((x=>Number(x.timestamp)<Number(thisTime)&&Number(x.title)>Number(thisTime)));skip&&(await player.seek(Number(skip.title)),percentage=(skip.title-start)/totaltime*100,replaceProgressBars(percentage))};if(player.useAnimationFrame){const animate=async()=>{await player.isPlaying()&&(intervalFunction(),onPlayingInterval=requestAnimationFrame(animate))};onPlayingInterval=requestAnimationFrame(animate)}else{await player.isPlaying()&&intervalFunction()}},onPause=()=>{cancelAnimationFrame(onPlayingInterval),$("#playpause").find("i").removeClass("bi-pause-fill").addClass("bi-play-fill").toggleClass("rotate-360")};require(["mod_interactivevideo/player/"+type],(function(VideoPlayer){1==displayoptions.passwordprotected&&($("#video-block").addClass("no-pointer bg-transparent"),$("#annotation-canvas").removeClass("d-none")),player=new VideoPlayer,player.load(url,start,end,{customStart:!0,passwordprotected:1==displayoptions.passwordprotected,showControls:!1}),window.IVPLAYER=player})),$(document).on("iv:playerReady",(function(){onReady()})),$(document).on("iv:playerPaused",(function(){onPause()})),$(document).on("iv:playerPlaying",(function(){onPlaying()})),$(document).on("iv:playerEnded",(function(){onEnded()})),$(document).on("iv:playerSeek",(function(e){onSeek(e.detail.time)})),$(document).on("iv:playerError",(function(){addNotification(M.util.get_string("thereisanissueloadingvideo","mod_interactivevideo"),"danger"),$("#annotation-canvas").removeClass("d-none"),$("#start-screen").addClass("d-none"),$("#video-block").addClass("no-pointer bg-transparent"),$("#spinner").remove(),$(".loader").removeClass("loader")}));let cacheCleared=!1;$(document).on("annotationupdated",(function(e){cacheCleared||$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"update_ivitems_cache",sesskey:M.cfg.sesskey,contextid:M.cfg.contextid,cmid:interaction},success:function(){cacheCleared=!0}});const action=e.originalEvent.detail.action;if("import"==action)return annotations=e.originalEvent.detail.annotations,renderAnnotationItems(annotations),void addNotification(M.util.get_string("interactionimported","mod_interactivevideo"),"success");let updated=e.originalEvent.detail.annotation;"edit"!=action&&"draft"!=action&&"savedraft"!=action||(annotations=annotations.filter((function(item){return item.id!=updated.id}))),updated.prop=JSON.stringify(contentTypes.find((x=>x.name===updated.type))),annotations.push(updated),activeid="add"==action?updated.id:null,annotations.map((x=>(x.editMode=!0,x))),renderAnnotationItems(annotations),"add"==action||"clone"==action?(addNotification(M.util.get_string("interactionadded","mod_interactivevideo"),"success"),$('tr[data-id="'.concat(updated.id,'"]')).addClass("active")):"edit"==action&&(addNotification(M.util.get_string("interactionupdated","mod_interactivevideo"),"success"),$('tr[data-id="'.concat(updated.id,'"]')).addClass("active"),setTimeout((function(){$('tr[data-id="'.concat(updated.id,'"]')).removeClass("active")}),1500)),annotations.find((x=>"draft"==x.status))?$("#timeline-wrapper #savedraft").removeAttr("disabled").addClass("pulse"):$("#timeline-wrapper #savedraft").attr("disabled","disabled").removeClass("pulse")})),$(document).on("annotationdeleted",(function(e){const annotation=e.originalEvent.detail.annotation;activeid=null,$('tr[data-id="'.concat(annotation.id,'"]')).addClass("deleted"),setTimeout((function(){annotations=annotations.filter((function(item){return item.id!=annotation.id})),renderAnnotationItems(annotations),addNotification(M.util.get_string("interactiondeleted","mod_interactivevideo"),"success")}),1e3)})),$(document).on("click","#addcontentdropdown .dropdown-item",(async function(e){if(!playerReady)return;if($("#addcontentdropdown .dropdown-item").removeClass("active"),$(e.target).is("a"))return;const ctype=$(this).data("type");player.pause();let timestamp=currentTime||await player.getCurrentTime();timestamp=Number(timestamp.toFixed(2));const contenttype=contentTypes.find((x=>x.name==ctype));if(contenttype.hastimestamp){if(annotations.find((x=>x.timestamp==timestamp)))return void addNotification(M.util.get_string("interactionalreadyexists","mod_interactivevideo"),"danger");if(annotations.filter((x=>"skipsegment"==x.type)).find((x=>Number(x.timestamp)<Number(currentTime)&&Number(x.title)>Number(currentTime))))return void addNotification(M.util.get_string("interactionisbetweentheskipsegment","mod_interactivevideo"),"danger")}contenttype.allowmultiple||!annotations.find((x=>x.type==ctype))?(currentTime=null,ctRenderer[ctype].addAnnotation(annotations,timestamp,coursemodule)):addNotification(M.util.get_string("thisinteractionalreadyexists","mod_interactivevideo",contenttype.title),"danger")})),$(document).on("click","tr.annotation .edit",(async function(e){e.preventDefault();const timestamp=$(this).closest(".annotation").data("timestamp"),id=$(this).closest(".annotation").data("id"),contenttype=$(this).closest(".annotation").data("type");ctRenderer[contenttype].editAnnotation(annotations,id,coursemodule),timestamp&&await player.seek(timestamp,!0),player.pause()})),$(document).on("click","tr.annotation .copy",(async function(e){e.preventDefault();const id=$(this).closest(".annotation").data("id"),contenttype=$(this).closest(".annotation").data("type"),time=await player.getCurrentTime();ctRenderer[contenttype].cloneAnnotation(id,time)})),$(document).on("click","tr.annotation .delete",(function(e){e.preventDefault(),player.pause();const id=$(this).closest(".annotation").data("id"),annotation=annotations.find((annotation=>annotation.id==id));try{Notification.deleteCancelPromise(M.util.get_string("deleteinteraction","mod_interactivevideo"),M.util.get_string("deleteinteractionconfirm","mod_interactivevideo"),M.util.get_string("delete","mod_interactivevideo")).then((()=>ctRenderer[annotation.type].deleteAnnotation(annotations,id))).catch((()=>{}))}catch{Notification.saveCancel(M.util.get_string("deleteinteraction","mod_interactivevideo"),M.util.get_string("deleteinteractionconfirm","mod_interactivevideo"),M.util.get_string("delete","mod_interactivevideo"),(function(){return ctRenderer[annotation.type].deleteAnnotation(annotations,id)}))}})),$(document).on("click","tr.annotation .title",(async function(e){e.preventDefault();const timestamp=$(this).closest(".annotation").data("timestamp");replaceProgressBars((timestamp-start)/totaltime*100),await player.getCurrentTime()!=timestamp&&await player.seek(timestamp,!0),player.pause();const id=$(this).closest(".annotation").data("id"),theAnnotation=annotations.find((annotation=>annotation.id==id));setTimeout((()=>{runInteraction(theAnnotation)}),500)})),$(document).on("click","tr.annotation .timestamp",(async function(e){e.preventDefault();const timestamp=$(this).data("timestamp");await player.seek(timestamp),player.play()})),$(document).on("contextmenu","#vseek, #video-timeline",(async function(e){if(!playerReady)return;e.preventDefault(),e.stopImmediatePropagation();const percentage=e.offsetX/$(this).width();replaceProgressBars(100*percentage),currentTime=percentage*totaltime+start,await player.seek(currentTime),player.pause(),$("#addcontent").trigger("click")})),$(document).on("contextmenu","#scrollbar, #scrollhead-top",(async function(e){playerReady&&(e.preventDefault(),e.stopImmediatePropagation(),currentTime=await player.getCurrentTime(),$("#addcontent").trigger("click"))})),$(document).on("click","#playpause",(async function(e){if(!playerReady)return;if(e.preventDefault(),await player.isPlaying())player.pause();else{await player.getCurrentTime()>=end?$("#end-screen #restart").trigger("click"):player.play()}})),$(document).on("click","#video-block",(function(e){playerReady&&(e.preventDefault(),$("#playpause").trigger("click"))})),$(document).on("contextmenu","#video-nav .annotation",(function(e){e.preventDefault(),e.stopImmediatePropagation();const id=$(this).data("id");$('tr.annotation[data-id="'.concat(id,'"] .edit')).trigger("click")})),$(document).on("contextmenu","[data-editable]",(function(e){if(e.preventDefault(),e.stopImmediatePropagation(),$("[data-field].editing").length>0)return;const fld=$(this).data("editable");$(this).hide(),$(this).siblings('[data-field="'+fld+'"]').removeClass("d-none").focus().addClass("editing"),"timestamp"==fld&&$(this).closest("tr").append('<div class="timestamp-info position-absolute">\n                        '.concat(M.util.get_string("rightclicktosetcurrenttime","mod_interactivevideo"),"</div>"))})),$(document).on("contextmenu",'[data-field="timestamp"]',(async function(e){e.preventDefault(),e.stopImmediatePropagation();const time=await player.getCurrentTime();$(this).val(convertSecondsToHMS(time,!1,!1))})),$(document).on("keyup","[data-field].editing",(function(e){$(this).removeClass("is-invalid");const initialValue=$(this).data("initial-value"),val=$(this).val(),fld=$(this).data("field");if(""==val&&$(this).addClass("is-invalid"),"Escape"==e.key)return $(this).val(initialValue),$(this).removeClass("editing"),$(this).addClass("d-none"),$(this).siblings("[data-editable]").show(),void $(".timestamp-info").remove();if("Enter"!=e.key);else{let seconds;if("timestamp"==fld){const parts=initialValue.split(":");if(seconds=3600*Number(parts[0])+60*Number(parts[1])+Number(parts[2]),!validateTimestampFormat(val,"[data-field].editing",initialValue))return void $(this).addClass("is-invalid");const timestamp=validateTimeStartEnd(val,"[data-field].editing",initialValue,seconds,!0,!0,!0);if(-1==timestamp)return void $(this).addClass("is-invalid");seconds=timestamp}if($(this).hasClass("is-invalid"))return;if(val==initialValue)return $(this).removeClass("editing"),$(this).addClass("d-none"),void $(this).siblings("[data-editable]").show();const id=$(this).data("id");$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"quick_edit_field",sesskey:M.cfg.sesskey,id:id,field:fld,contextid:M.cfg.contextid,value:"timestamp"==fld?seconds:val},success:function(data){$(".timestamp-info").remove();const updated=JSON.parse(data);dispatchEvent("annotationupdated",{annotation:updated,action:"edit"})}})}})),$(document).on("blur","[data-field].editing",(function(){const initialValue=$(this).data("initial-value");$(this).val(initialValue),$(this).removeClass("editing"),$(this).addClass("d-none"),$(this).siblings("[data-editable]").show(),$(".timestamp-info").remove()})),$(document).on("click","#end-screen #restart",(async function(e){e.preventDefault(),$("#end-screen").remove(),await player.seek(start),player.play()})),$(document).on("mouseover","tr.annotation",(function(){const id=$(this).data("id");$('#video-nav ul li[data-id="'.concat(id,'"] .item')).trigger("mouseover")})),$(document).on("mouseout","tr.annotation",(function(){const id=$(this).data("id");$('#video-nav ul li[data-id="'.concat(id,'"] .item')).trigger("mouseout"),$(".tooltip").remove()})),$(document).on("mouseover","#video-nav ul li",(function(){const id=$(this).data("id");$('tr.annotation[data-id="'.concat(id,'"]')).addClass("active")})),$(document).on("mouseout","#video-nav ul li",(function(){const id=$(this).data("id");$('tr.annotation[data-id="'.concat(id,'"]')).removeClass("active")})),$(document).on("change",".timestamp-input, .timestamp-field input",(function(){$(this).removeClass("is-invalid");const parts=$(this).val().split(":"),seconds=3600*Number(parts[0])+60*Number(parts[1])+Number(parts[2]);if(!validateTimestampFormat($(this).val(),this))return void $(this).addClass("is-invalid");-1!=validateTimeStartEnd($(this).val(),this,"00:00:00",seconds,!0,!1,!0)||$(this).addClass("is-invalid")}));const appendTimestampMarker=(seconds,rounded)=>{const formattedTime=convertSecondsToHMS(seconds,!0,rounded);$("#vseek #bar").append('<div id="position-marker">\n                    <div id="position" class="py-0 px-1" style="top:-25px;">'.concat(formattedTime,"</div></div>"))};$(document).on("annotationitemsrendered",(function(){$('#timeline-wrapper [data-toggle="tooltip"]').tooltip({boundary:"window",container:"#timeline"});let targetAnnotation=null;try{$("#timeline-items .annotation, #video-timeline-wrapper .skipsegment").draggable("destroy"),$("#timeline-items .annotation, #video-timeline-wrapper .skipsegment").resizable("destroy")}catch(e){}$("#timeline-items .annotation.li-draggable").draggable({axis:"x",start:async function(){await player.isPaused()||player.pause(),appendTimestampMarker($(this).data("timestamp")),$(".tooltip, #message").remove(),$("#timeline-items").addClass("no-pointer-events")},drag:async function(event,ui){$(".tooltip").remove();let timestamp=(ui.position.left+5)/$("#timeline-items").width()*totaltime+start;timestamp<start&&(timestamp=start,ui.position.left=-5),timestamp>end&&(timestamp=end,ui.position.left=$("#timeline-items").width()-5);let percentage=(timestamp-start)/totaltime*100;percentage<0&&(percentage=0),$("#scrollbar, #position-marker, #scrollhead-top").css("left",percentage+"%"),$(this).css("left",percentage+"%"),await player.seek(timestamp),$("#vseek #position").text(convertSecondsToHMS(timestamp,!0,!1))},stop:async function(event,ui){$(".tooltip").remove(),$("#vseek #position-marker").remove(),setTimeout((function(){$("#timeline-items").removeClass("no-pointer-events")}),200);let timestamp=(ui.position.left+5)/$("#timeline-items").width()*totaltime+start;timestamp<start&&(timestamp=start,$(this).css("left","-5px")),timestamp>end&&(timestamp=end,$(this).css("left","calc(100% - 5px)"));let percentage=(timestamp-start)/totaltime*100;percentage<0&&(percentage=0),$("#scrollbar, #position-marker, #scrollhead-top").css("left",percentage+"%");const id=$(this).data("id");targetAnnotation=annotations.find((x=>x.id==id));if(annotations.find((x=>x.timestamp==timestamp&&x.id!=id)))return addNotification(M.util.get_string("interactionalreadyexists","mod_interactivevideo"),"danger"),void renderAnnotationItems(annotations);targetAnnotation.timestamp!=timestamp&&(targetAnnotation.timestamp=timestamp,targetAnnotation.status="draft",dispatchEvent("annotationupdated",{annotation:targetAnnotation,action:"draft"}),$("#scrollbar, #position-marker, #scrollhead-top").css("left",percentage+"%"))}}),$("#video-timeline-wrapper .skipsegment").draggable({axis:"x",start:async function(){await player.isPaused()||player.pause(),$("#message").remove(),appendTimestampMarker($(this).data("timestamp")),$("#timeline-items").addClass("no-pointer-events")},drag:async function(event,ui){const id=$(this).data("id");targetAnnotation=annotations.find((x=>x.id==id));let timestamp=ui.position.left/$("#video-timeline").width()*totaltime+start;timestamp<start&&(timestamp=start),timestamp>end&&(timestamp=end);let percentage=(timestamp-start)/totaltime*100;percentage<0&&(percentage=0),$("#scrollbar, #position-marker, #scrollhead-top").css("left",percentage+"%"),await player.seek(timestamp),$("#vseek #position").text(convertSecondsToHMS(timestamp,!0,!1))},stop:async function(event,ui){$("#vseek #position-marker").remove(),setTimeout((function(){$("#timeline-items").removeClass("no-pointer-events")}),200);let timestamp=ui.position.left/$("#video-timeline").width()*totaltime+start;const id=$(this).data("id");targetAnnotation=annotations.find((x=>x.id==id));let skipduration=Number(targetAnnotation.title)-Number(targetAnnotation.timestamp);if(timestamp<0&&timestamp+skipduration<start)return void renderAnnotationItems(annotations);if(timestamp>end)return void renderAnnotationItems(annotations);if(timestamp<start&&(skipduration-=Math.abs(start-timestamp),timestamp=start),timestamp+skipduration>end&&(skipduration=Math.abs(end-timestamp),timestamp=end-skipduration),skipduration<=0)return void renderAnnotationItems(annotations);if(annotations.find((x=>x.timestamp==timestamp&&x.id!=id)))return addNotification(M.util.get_string("interactionalreadyexists","mod_interactivevideo"),"danger"),void renderAnnotationItems(annotations);if(targetAnnotation.timestamp==timestamp)return void renderAnnotationItems(annotations);targetAnnotation.timestamp=timestamp,targetAnnotation.title=timestamp+skipduration,targetAnnotation.title>end&&(targetAnnotation.title=end),targetAnnotation.status="draft",dispatchEvent("annotationupdated",{annotation:targetAnnotation,action:"draft"});let percentage=(timestamp-start)/totaltime*100;percentage<0&&(percentage=0),$("#scrollbar, #position-marker, #scrollhead-top").css("left",percentage+"%")}}),$("#video-timeline-wrapper .skipsegment").resizable({containment:"#video-timeline-wrapper",handles:"e, w",start:async function(){await player.isPaused()||player.pause(),$("#message").remove(),appendTimestampMarker($(this).data("timestamp")),$("#timeline-items").addClass("no-pointer-events")},resize:async function(event,ui){let timestamp;ui.originalPosition.left!=ui.position.left||ui.originalSize.width==ui.size.width?(ui.position.left<0&&(ui.position.left=0),timestamp=ui.position.left/$("#video-timeline").width()*totaltime+start):timestamp=(ui.position.left+ui.size.width)/$("#video-timeline").width()*totaltime+start;let percentage=(timestamp-start)/totaltime*100;(isNaN(percentage)||percentage<0)&&(percentage=0),percentage>100&&(percentage=100),$("#scrollbar, #position-marker, #scrollhead-top").css("left",percentage+"%"),await player.seek(timestamp),$("#vseek #position").text(convertSecondsToHMS(timestamp,!0,!1))},stop:async function(event,ui){$("#vseek #position-marker").remove(),setTimeout((function(){$("#timeline-items").removeClass("no-pointer-events")}),200);const id=$(this).data("id");let timestamp,direction;targetAnnotation=annotations.find((x=>x.id==id)),ui.originalPosition.left!=ui.position.left?(ui.position.left<0&&(ui.position.left=0),timestamp=ui.position.left/$("#video-timeline").width()*totaltime+start,direction="left"):(timestamp=(ui.position.left+ui.size.width)/$("#video-timeline").width()*totaltime+start,direction="right");if(annotations.find((x=>x.timestamp==timestamp&&x.id!=id)))return addNotification(M.util.get_string("interactionalreadyexists","mod_interactivevideo"),"danger"),void renderAnnotationItems(annotations);if(targetAnnotation.timestamp==timestamp)return;"left"==direction?targetAnnotation.timestamp=timestamp:(targetAnnotation.title=timestamp,targetAnnotation.title>end&&(targetAnnotation.title=end)),targetAnnotation.status="draft",dispatchEvent("annotationupdated",{annotation:targetAnnotation,action:"draft"});let percentage=(timestamp-start)/totaltime*100;(isNaN(percentage)||percentage<0)&&(percentage=0),percentage>100&&(percentage=100),$("#scrollbar, #position-marker, #scrollhead-top").css("left",percentage+"%")}}),$("#video-timeline-wrapper .skipsegment").off("contextmenu").on("contextmenu",(function(e){e.preventDefault(),e.stopImmediatePropagation();const id=$(this).data("id");$('tr.annotation[data-id="'.concat(id,'"] .edit')).trigger("click")})),$("#video-timeline-wrapper .skipsegment").off("click").on("click",(async function(e){e.preventDefault();const timestamp=$(this).data("timestamp");await player.seek(timestamp);await player.isPaused()||player.pause()})),$("#video-timeline-wrapper .skipsegment .delete-skipsegment").off("click").on("click",(function(e){e.preventDefault();const id=$(this).closest(".skipsegment").data("id");$('tr.annotation[data-id="'.concat(id,'"] .delete')).trigger("click")}))})),$("#scrollbar").draggable({containment:"#timeline-items",axis:"x",cursor:"col-resize",start:async function(event,ui){await player.isPaused()||player.pause(),$("#timeline-items").addClass("no-pointer-events"),$("#message").remove(),appendTimestampMarker(ui.position.left/$("#timeline-items").width()*totaltime+start,!1)},drag:async function(event,ui){let timestamp=ui.position.left/$("#timeline-items").width()*totaltime+start,percentage=(timestamp-start)/totaltime*100;$("#vseek #position").text(convertSecondsToHMS(timestamp,!0,!1)),$("#vseek #position-marker, #scrollhead-top, #scrollbar").css("left",percentage+"%"),await player.seek(timestamp)},stop:async function(event,ui){$("#vseek #position-marker").remove(),setTimeout((function(){$("#timeline-items").removeClass("no-pointer-events")}),200);let percentage=(ui.position.left/$("#timeline-items").width()*totaltime+start-start)/totaltime*100;(isNaN(percentage)||percentage<0)&&(percentage=0),percentage>100&&(percentage=100),$("#scrollbar, #scrollhead-top").css("left",percentage+"%");await player.isPaused()||player.pause()}}),$("#scrollhead-top").draggable({axis:"x",cursor:"col-resize",start:async function(event,ui){await player.isPaused()||player.pause(),$("#vseek").addClass("no-pointer-events"),$("#message").remove(),appendTimestampMarker(ui.position.left/$("#vseek").width()*totaltime+start,!1)},drag:async function(event,ui){let timestamp=ui.position.left/$("#vseek").width()*totaltime+start,percentage=(timestamp-start)/totaltime*100;(isNaN(percentage)||percentage<0)&&(percentage=0),percentage>100&&(percentage=100),timestamp<start&&(timestamp=start),$("#vseek #position").text(convertSecondsToHMS(timestamp,!0,!1)),$("#vseek #position-marker, #scrollhead-top, #scrollbar").css("left",percentage+"%"),await player.seek(timestamp)},stop:async function(event,ui){$("#vseek #position-marker").remove(),setTimeout((function(){$("#vseek").removeClass("no-pointer-events")}),200);let timestamp=ui.position.left/$("#vseek").width()*totaltime+start;timestamp<start&&(timestamp=start);let percentage=(timestamp-start)/totaltime*100;(isNaN(percentage)||percentage<0)&&(percentage=0),percentage>100&&(percentage=100),$("#scrollbar, #scrollhead-top").css("left",percentage+"%");await player.isPaused()||player.pause()}}),$("#timeline-wrapper").resizable({handles:"n",minHeight:125,maxHeight:500,start:function(){$("#top-region, #timeline-wrapper").addClass("no-pointer-events")},resize:function(event,ui){$("#top-region").css("height","calc(100dvh - ".concat(ui.size.height+70,"px)"))},stop:function(){$("#top-region, #timeline-wrapper").removeClass("no-pointer-events"),localStorage.setItem("timeline-height",$("#timeline-wrapper").height())}}),$("#separator").draggable({axis:"x",containment:"#wrapper",grid:[1,0],start:function(){$("#wrapper").addClass("no-pointer-events")},drag:function(){const width=$(this).offset().left;$("#player-region").css("width",width+"px"),$("#content-region").css("width","calc(100% - "+width+"px)")},stop:function(){const width=$(this).offset().left;localStorage.setItem("player-width",width),$("#wrapper").removeClass("no-pointer-events")}});const playerWidth=localStorage.getItem("player-width");playerWidth&&window.innerWidth>992&&($("#separator").css("left",playerWidth+"px"),$("#player-region").css("width",playerWidth+"px"),$("#content-region").css("width","calc(100% - "+playerWidth+"px)"));const timelineHeight=localStorage.getItem("timeline-height");timelineHeight&&($("#timeline-wrapper").css("height",timelineHeight+"px"),$("#top-region").css("height","calc(100dvh - ".concat(Number(timelineHeight)+70,"px)"))),$("#vseek #bar, #video-timeline, #video-nav .annotation").on("mouseenter",(function(e){$("#cursorbar, #position-marker").remove(),e.preventDefault(),e.stopImmediatePropagation();let $scrollbar=$("#scrollbar").clone();$scrollbar.attr("id","cursorbar");const parentOffset=$(this).offset(),relX=e.pageX-parentOffset.left;$scrollbar.css("left",relX+5+"px"),$scrollbar.find("#scrollhead").remove();const percentage=relX/$(this).width(),formattedTime=convertSecondsToHMS(percentage*totaltime+start,!0,!1);$("#vseek #bar").append('<div id="position-marker">\n                    <div id="position" class="py-0 px-1" style="top:-25px;">'.concat(formattedTime,"</div></div>")),$("#vseek #position-marker").css("left",relX+"px"),$("#timeline-items").append($scrollbar)})),$("#vseek #bar, #video-timeline, #video-nav .annotation").on("mouseleave",(function(e){e.stopImmediatePropagation(),$("#vseek #position-marker, #cursorbar").remove()})),$("#vseek #bar, #video-timeline").on("mousemove",(function(e){e.stopImmediatePropagation();const parentOffset=$(this).offset(),relX=e.pageX-parentOffset.left;let time=relX/$(this).width()*totaltime+start;time<start&&(time=start);const formattedTime=convertSecondsToHMS(time,!0,!1);$("#cursorbar").css("left",relX+5+"px"),$("#vseek #position").text(formattedTime),$("#vseek #position-marker").css("left",relX+"px")})),$(document).on("click","#video-nav .annotation",(async function(e){e.preventDefault(),e.stopImmediatePropagation();const id=$(this).data("id"),annotation=annotations.find((x=>x.id==id));$loader.fadeIn(300),await player.getCurrentTime()!=annotation.timestamp&&await player.seek(annotation.timestamp),$loader.fadeOut(300),runInteraction(annotation)})),$(document).on("click","#vseek #bar, #video-timeline",(async function(e){e.preventDefault(),e.stopImmediatePropagation();const percentage=e.offsetX/$(this).width();replaceProgressBars(100*percentage),$loader.fadeIn(300);await player.isPaused()||player.pause(),await player.seek(percentage*totaltime+start),$loader.fadeOut(300),$("#message, #end-screen").remove()})),$("#zoomout").on("click",(function(){const currentLevel=$("#timeline-items-wrapper").css("width"),newLevel=parseInt(currentLevel)-300;$("#timeline-items-wrapper").css("width",newLevel+"px");const relWidth=$("#timeline-items").width();$("#minute-markers, #minute-markers-bg, #vseek").css("width",relWidth+"px");let timelineElement=document.getElementById("timeline");timelineElement.scrollWidth<=timelineElement.clientWidth&&$(this).attr("disabled","disabled"),dispatchEvent("annotationitemsrendered",{annotations:annotations})})),$("#zoomin").on("click",(function(){const currentLevel=$("#timeline-items-wrapper").css("width"),newLevel=parseInt(currentLevel)+300;$("#timeline-items-wrapper").css("width",newLevel+"px");const relWidth=$("#timeline-items").width();$("#minute-markers, #minute-markers-bg, #vseek").css("width",relWidth+"px"),$("#zoomout").removeAttr("disabled"),dispatchEvent("annotationitemsrendered",{annotations:annotations})})),$("#timeline").on("wheel",(function(e){(e.ctrlKey||e.metaKey)&&(e.preventDefault(),e.originalEvent.deltaY<0?$("#zoomin").trigger("click"):$("#zoomout").trigger("click"))})),document.getElementById("timeline").addEventListener("scroll",(function(){document.getElementById("minute-markers-wrapper").scrollLeft=this.scrollLeft,document.getElementById("vseek").style.left=-this.scrollLeft+"px",document.getElementById("minute-markers-bg-wrapper").style.left=-this.scrollLeft+"px",document.getElementById("scrollbar").scrollHeight=this.scrollHeight})),$("#savedraft").on("click",(function(e){e.stopImmediatePropagation();let draftAnnotations=annotations.filter((x=>"draft"==x.status)),count=0;draftAnnotations.forEach((function(a){$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"quick_edit_field",sesskey:M.cfg.sesskey,id:a.id,field:"timestamp",contextid:M.cfg.contextid,value:a.timestamp},success:function(data){const updated=JSON.parse(data);dispatchEvent("annotationupdated",{annotation:updated,action:"savedraft"})}}),"skipsegment"==a.type&&$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"quick_edit_field",sesskey:M.cfg.sesskey,id:a.id,field:"title",contextid:M.cfg.contextid,value:a.title},success:function(data){const updated=JSON.parse(data);dispatchEvent("annotationupdated",{annotation:updated,action:"savedraft"})}}),count++,count==draftAnnotations.length&&addNotification(M.util.get_string("draftsaved","mod_interactivevideo"),"success")}))})),$("#addcontent").on("click",(async function(e){e.preventDefault(),playerReady&&$("#contentmodal").modal("show")})),$("#contentmodal").on("show.bs.modal",(function(){player.pause(),$("#addcontentdropdown").addClass("modal-body")})),$("#contentmodal").on("hide.bs.modal",(function(){$("#addcontentdropdown .dropdown-item").removeClass("active"),$("#addcontentdropdown").removeClass("modal-body")})),window.addEventListener("beforeunload",(e=>{if(annotations.find((x=>"draft"==x.status))){const confirmationMessage=M.util.get_string("unsavedchanges","mod_interactivevideo");return e.returnValue=confirmationMessage,confirmationMessage}return!0})),$(document).on("click",".changerate",(function(e){e.preventDefault();const rate=$(this).data("rate");player.setRate(rate),$(".changerate").find("i").removeClass("bi-check"),$(this).find("i").addClass("bi-check")})),$(document).on("iv:playerRateChange",(function(e){$(".changerate").find("i").removeClass("bi-check"),$('.changerate[data-rate="'.concat(e.originalEvent.detail.rate,'"]')).find("i").addClass("bi-check")})),$("#changequality").on("shown.bs.dropdown",(async function(){let quality=await player.getQualities();$("#qualitieslist").empty();let currentQuality=quality.currentQuality;null===currentQuality&&(currentQuality=$(this).data("current"));let qualities=quality.qualities,qualitiesLabel=quality.qualitiesLabel;qualities.forEach(((q,i)=>{$("#qualitieslist").append('<a class="dropdown-item changequality" data-quality="'.concat(q,'"\n                         href="#"><i class="bi ').concat(q==currentQuality?"bi-check":"",' fa-fw ml-n3"></i>').concat(qualitiesLabel[i],"</a>"))})),$(this).find("[data-toggle=dropdown]").dropdown("update")})),$(document).on("click",".changequality",(function(e){e.preventDefault();const quality=$(this).data("quality");player.setQuality(quality),$(".changequality").find("i").removeClass("bi-check"),$(this).find("i").addClass("bi-check")}));let timelineWrapper=document.getElementById("timeline-wrapper"),resizeObserver=new ResizeObserver((()=>{const relWidth=$("#timeline-items").width();$("#minute-markers, #minute-markers-bg, #vseek").css("width",relWidth+"px")}));resizeObserver.observe(timelineWrapper),$(document).on("click","#importcontent",(function(e){e.preventDefault();const importmodal='<div class="modal fade" id="importmodal" tabindex="-1" aria-labelledby="importmodalLabel"\n                 aria-hidden="true">\n                    <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable modal-lg">\n                        <div class="modal-content">\n                            <div class="modal-header">\n                                <h5 class="modal-title" id="importmodalLabel">\n                                '.concat(M.util.get_string("importcontent","mod_interactivevideo"),'</h5>\n                                <button type="button" class="btn p-0 border-0" data-dismiss="modal" aria-label="Close">\n                                    <i class="bi bi-x-lg fa-fw fs-25px"></i>\n                                </button>\n                            </div>\n                            <div class="modal-body">\n                            </div>\n                            <div class="modal-footer">\n                                <button type="button" class="btn btn-secondary border-0" data-dismiss="modal">\n                                ').concat(M.util.get_string("cancel","mod_interactivevideo"),'</button>\n                                <button type="button" class="btn btn-primary border-0" id="importcontentbutton">\n                                ').concat(M.util.get_string("import","mod_interactivevideo"),"</button>\n                            </div>\n                        </div>\n                    </div>\n                </div>");$("body").append(importmodal),$("#importmodal").modal("show"),$("#importmodal").on("hidden.bs.modal",(function(){$("#importmodal").remove()})),$("#importmodal").off("shown.bs.modal").on("shown.bs.modal",(function(){$("#importmodal .modal-dialog").draggable({handle:".modal-header"}),$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_taught_courses",sesskey:M.cfg.sesskey,contextid:M.cfg.contextid,userid:userid},success:function(data){let courses=JSON.parse(data);courses.sort(((a,b)=>a.fullname.localeCompare(b.fullname)));let courseSelect='<select class="custom-select w-100" id="importcourse">';courses.forEach((course=>{courseSelect+='<option value="'.concat(course.id,'">').concat(course.fullname," (").concat(course.shortname,")</option>")})),courseSelect+="</select>";let selectfield='<div class="form-group selectcourse">\n                            <label class="font-weight-bold" for="importcourse">\n                            '.concat(M.util.get_string("selectcourse","mod_interactivevideo"),"</label>\n                            ").concat(courseSelect,"</div>");$("#importmodal .modal-body").append(selectfield),$("#importmodal #importcourse").val(course),$("#importmodal #importcourse").trigger("change")}})}))})),$(document).on("change","#importmodal #importcourse",(function(){$("#importmodal .selectcm, #importmodal .select-interaction").remove(),$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_cm_by_courseid",sesskey:M.cfg.sesskey,contextid:M.cfg.contextid,courseid:$(this).val()},success:function(data){let cms=JSON.parse(data);cms.sort(((a,b)=>a.name.localeCompare(b.name)));let cmSelect='<select class="custom-select w-100" id="importcm">\n                        <option value="">'.concat(M.util.get_string("select","mod_interactivevideo"),"</option>");cms.forEach((cm=>{cmSelect+='<option value="'.concat(cm.id,'" ').concat(cm.id==interaction?"disabled":"",">").concat(cm.name,"</option>")})),cmSelect+="</select>";let selectfield='<div class="form-group selectcm">\n                        <label for="importcm" class="font-weight-bold">\n                        '.concat(M.util.get_string("selectactivity","mod_interactivevideo"),"</label>\n                        ").concat(cmSelect,"</div>");$("#importmodal .selectcourse").after(selectfield)}})})),$(document).on("change","#importmodal #importcm",(async function(){$("#importmodal .select-interaction").remove(),$("#importmodal #importcm").after('<div class="select-interaction py-3">\n                    <iframe src="'.concat(M.cfg.wwwroot+"/mod/interactivevideo/view.php?i="+$(this).val(),'&embed=1&preview=1"\n                    frameborder=0 width="100%" height="500" class="loader"></iframe></div>'));let interactions=await $.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_items",sesskey:M.cfg.sesskey,id:$(this).val(),contextid:M.cfg.contextid,coursecontextid:M.cfg.courseContextId}});interactions=JSON.parse(interactions),interactions=interactions.filter((x=>"skipsegment"!=x.type)),0!=interactions.length?($("#importmodal .select-interaction").append('<div class="input-group mb-1 w-100 flex-nowrap align-items-center\n                     no-pointer">\n                     <div class="input-group-prepend border-0 invisible">\n                            <label class="input-group-text bg-white">\n                                <input type="checkbox"/>\n                                <i class="bi bi-plus ml-3 fs-unset"></i>\n                            </label>\n                        </div>\n                <input type="text" class="form-control border-0 font-weight-bold"\n                 value="'.concat(M.util.get_string("title","mod_interactivevideo"),'">\n                <input type="text" class="form-control border-0 font-weight-bold" style="max-width: 50px;"\n                value="XP">\n                <input type="text" style="max-width: 150px;" value="').concat(M.util.get_string("timestamp","mod_interactivevideo"),'"\n                 class="form-control border-0 font-weight-bold"></div>')),interactions=interactions.map((int=>{const ctype=contentTypes.find((y=>y.name===int.type));return int.prop=JSON.stringify(ctype),int.icon=ctype.icon,(int.timestamp>end||int.timestamp<start)&&int.timestamp>0?int.outside=!0:int.outside=!1,!ctype.allowmultiple&&annotations.find((x=>x.type==int.type))&&(int.disabled=!0),int})),interactions.sort(((a,b)=>a.timestamp-b.timestamp)),interactions.forEach((int=>{const inputgroup='<div class="input-group mb-1 w-100 flex-nowrap align-items-center"\n                     data-id="'.concat(int.id,'">\n                        <div class="input-group-prepend">\n                            <label class="input-group-text">\n                                <input type="checkbox" ').concat(int.disabled?"disabled":"",'/>\n                                <i class="').concat(int.icon,' ml-3 fs-unset"></i>\n                            </label>\n                        </div>\n                <input type="text" class="form-control name" ').concat(int.timestamp<0?"readonly":"",'\n                 value="').concat(int.title,'">\n                <input type="text" style="max-width: 50px;" ').concat(int.timestamp<0||0==int.hascompletion?"readonly":"",'\n                 class="form-control xp" value="').concat(int.xp,'">\n                <input type="text" placeholder="00:00:00" style="max-width: 150px;" ').concat(int.timestamp<0?"readonly":"",'\n                 class="form-control timestamp-input ').concat(int.outside?"is-invalid":"",'"\n                value="').concat(int.timestamp<0?int.timestamp:convertSecondsToHMS(int.timestamp,!1,!1),'"></div>');$("#importmodal .select-interaction").append(inputgroup)})),$(document).off("click","#importmodal #importcontentbutton").on("click","#importmodal #importcontentbutton",(async function(e){e.preventDefault();let $selected=$('#importmodal .select-interaction input[type="checkbox"]:checked'),selectedInt=[];if($selected.each((function(){let $row=$(this).closest(".input-group");const name=$row.find(".name").val();if(""==name.trim())return;let timestamp=$row.find(".timestamp-input").val();if(""==timestamp)return;if(Number(timestamp)<0)timestamp=Number(timestamp);else{const parts=timestamp.split(":");if(timestamp=3600*Number(parts[0])+60*Number(parts[1])+Number(parts[2]),annotations.find((x=>x.timestamp==timestamp)))return}let id=$row.data("id"),int=interactions.find((x=>x.id==id));int.title=name,int.timestamp=timestamp;let xp=Number($row.find(".xp").val());(isNaN(xp)||""==xp)&&(xp=0),int.xp=xp,selectedInt.push(int)})),0!=selectedInt.length){let interactions=await $.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"import_annotations",sesskey:M.cfg.sesskey,contextid:M.cfg.contextid,annotations:JSON.stringify(selectedInt),tocourse:M.cfg.courseId,fromcourse:$("#importcourse").val(),tocm:interaction,fromcm:$("#importcm").val(),module:coursemodule}});interactions=JSON.parse(interactions),$("#importmodal").modal("hide"),annotations=annotations.concat(interactions),dispatchEvent("annotationupdated",{annotations:annotations,action:"import"}),interactions.forEach((int=>{int.allowmultiple||ctRenderer[int.type].init()}))}else addNotification(M.util.get_string("selectinteraction","mod_interactivevideo"),"danger")}))):$("#importmodal .select-interaction").append('<div class="alert alert-warning mt-3">\n                        '.concat(M.util.get_string("nocontent","mod_interactivevideo"),"</div>"))})),$(document).on("keyup","#contentmodal #contentsearch",(function(){let search=$(this).val().toLowerCase();$("#addcontentdropdown .dropdown-item").removeClass("d-none").addClass("d-flex"),""!=search&&$("#contentmodal #addcontentdropdown .dropdown-item").each((function(){$(this).find(".contenttype-title").text().toLowerCase().includes(search)?$(this).addClass("d-flex").removeClass("d-none"):$(this).addClass("d-none").removeClass("d-flex")}))}));const fastforward=async e=>{let time=await player.getCurrentTime();time>=end||(e.ctrlKey||e.metaKey?time+=1:time+=.2,time>end&&(time=end),await player.seek(time))};let fastForwardInterval;$(document).on("click","#fast-forward",(async function(e){e.preventDefault(),fastforward(e)})),$(document).on("mousedown","#fast-forward",(async function(e){e.preventDefault(),fastForwardInterval=setInterval((async()=>{fastforward(e),await player.getCurrentTime()>=end&&clearInterval(fastForwardInterval)}),200)})),$(document).on("mouseup mouseleave","#fast-forward",(function(){clearInterval(fastForwardInterval)}));const rewind=async e=>{let time=await player.getCurrentTime();time<=start||(e.ctrlKey||e.metaKey?time-=1:time-=.2,time<start&&(time=start),await player.seek(time))};let rewindInterval;$(document).on("click","#rewind",(async function(e){e.preventDefault(),rewind(e)})),$(document).on("mousedown","#rewind",(async function(e){e.preventDefault(),rewindInterval=setInterval((async()=>{rewind(e),await player.getCurrentTime()<=start&&clearInterval(rewindInterval)}),200)})),$(document).on("mouseup mouseleave","#rewind",(function(){clearInterval(rewindInterval)})),window.addEventListener("beforeunload",(function(){$(document).off(),cancelAnimationFrame(onPlayingInterval)}))}}}));

//# sourceMappingURL=editannotation.min.js.map